/**
 * ThumbNailAppendableEntry.java
 * Created on 2005/06/13
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.cache;

import java.io.IOException;

/**
 * ǉꂽR[hɑ΂ēYt̏kډ摜̎t\ȃGg
 * @author es
 */
public abstract class ThumbNailAppendableEntry extends CacheEntry {

    private boolean isMake;

    /**
     * @param factory ̃Gg̊Ǘt@Ng
     */
    public ThumbNailAppendableEntry(CacheFactory factory) {
        this(factory, true);
    }

    /**
     * @param factory ̃Gg̊Ǘt@Ng
     * @param isMakeThumb Yt̏kډ摜t邩?
     */
    public ThumbNailAppendableEntry(CacheFactory factory, boolean isMakeThumb) {
        super(factory);
        isMake = isMakeThumb;
    }

    /* ( Javadoc)
     * @see izayoi.cache.CacheEntry#append(izayoi.cache.Record)
     */
    public final void append(Record record) throws IOException {
        if (isMakeThumbNail()) {
            makeThumbNail(record);
        }
        appendRecord(record);
    }

    /**
     * R[hǉ ( izayoi.cache.CacheEntry#append(izayoi.cache.Record) ̑)
     * @param record
     * @throws IOException
     */
    abstract public void appendRecord(Record record) throws IOException;

    public final boolean isMakeThumbNail() {
        return isMake;
    }

    /**
     * kڍ쐬
     * @param record
     * @throws IOException
     */
    abstract protected void makeThumbNail(Record record) throws IOException;

}
