/**
 * Node.java
 * Created on 2005/05/23
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.node;

import izayoi.cache.Record;

import java.io.IOException;
import java.net.ProtocolException;
import java.net.URL;

/**
 * um[hv
 * alternate of net.sourceforge.shingetsu.node.Node
 * @author es
 */
public interface Node {

    /**
     * w/byex𔭍s
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#bye()
     */
    public void bye() throws ProtocolException, IOException;

    /**
     * w/getx𔭍s
     * @param filename t@C
     * @param timeArgument w
     * @return Ɉv郌R[h
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#get(java.lang.String, java.lang.String)
     */
    public Record[] get(String filename, String timeArgument) throws ProtocolException, IOException;

    /**
     * ̃m[hURL擾
     * @return ̃m[hURL
     */
    public URL getServantURL();

    /**
     * w/havex𔭍s
     * @param filename t@C
     * @return t@CL
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public boolean have(String filename) throws ProtocolException, IOException;

    /**
     * w/headx𔭍s
     * @param filename t@C
     * @param timeArgument w
     * @return Ɉv郌R[h
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#head(java.lang.String, java.lang.String)
     */
    public String[] head(String filename, String timeArgument) throws ProtocolException, IOException;

    /**
     * w/joinx𔭍s
     * @return m[hURLA܂͎g
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#join()
     */
    public URL join() throws ProtocolException, IOException;

    /**
     * w/nodex𔭍s
     * @return m[hURL
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#node()
     */
    public URL node() throws ProtocolException, IOException;

    /**
     * w/pingx𔭍s
     * @return 悪LȂ^
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#ping()
     */
    public boolean ping() throws ProtocolException, IOException;

    /**
     * w/x𔭍s
     * @return 扞bZ[W
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#root()
     */
    public String[] root() throws ProtocolException, IOException;

    /**
     * ̃m[hɑ΂Am[hԒʐMs
     * @param command m[hԒʐM
     * @param argument 
     * @return X|X
     * @throws IOException
     * @throws ProtocolException
     */
    public String[] talk(String command, String argument) throws IOException, ProtocolException;

    /**
     * w/updatex𔭍s
     * @param filename
     * @param timeArgument
     * @param md5
     * @param nodeStr
     * @throws ProtocolException X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     * @see net.sourceforge.shingetsu.node.Node#update(java.lang.String, java.lang.String, java.lang.String, net.sourceforge.shingetsu.node.Node)
     */
    public void update(String filename, String timeArgument, String md5, String nodeStr) throws IOException, ProtocolException;

}
