package izayoi.servlet;

import izayoi.Configures;
import izayoi.Izayoi;
import izayoi.cache.CacheFactory;
import izayoi.client.Client;
import izayoi.node.NodeController;
import izayoi.node.NodeControllerFactory;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * AvP[VvOCƂɂpƊyȂ
 * @author es
 */
public abstract class BasementServlet extends HttpServlet implements ServletConstants {

    private boolean needThumb;

    /**LbVǗNX*/
    protected CacheFactory cache;

    /**ݒێNX*/
    protected Configures conf;

    /**m[hǗNX*/
    protected NodeController node;

    /**NCAg*/
    protected Client client;

    //URL̓p^[
    private static final Pattern PATTERN_URL =
        Pattern.compile("\\/[\\w|\\.]+(\\/([\\w|\\%|\\.|\\-|\\+]+))?(\\/([\\w|\\%|\\.|\\-|\\+]+))?(\\/([\\w|\\%|\\.|\\-|\\+]+))?");

    //debug
    private boolean isSilence = false;

    /* ( Javadoc)
     * @see javax.servlet.Servlet#destroy()
     */
    public void destroy() {
        super.destroy();
    }

    /* ( Javadoc)
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        tweak(req, res);
    }

    /* ( Javadoc)
     * @see javax.servlet.http.HttpServlet#doPut(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        tweak(req, res);
    }

    /*
     * ׍HX
     * @param req
     * @param res
     * @throws ServletException
     * @throws IOException
     */
    private void tweak(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        res.setHeader("Server", Izayoi.VERSION + " @" + getServletContext().getServerInfo());
        setAttr(req);
        execute(req, res);
    }

    /**
     * cookieattributeɗ
     * @param req
     */
    private void setAttr(HttpServletRequest req) {
        Cookie[] c = req.getCookies();
        if (c == null) {
            c = new Cookie[0];
        }
        //@TODO Ƃǁ[ɂȂ
        for (int i = 0; i < c.length; i++) {
        	String name = c[i].getName();
            if (name.equals(PARAM_STYLE)) {
                if (c[i].getValue().matches("(\\w|-)+")) {
                    req.setAttribute(PARAM_STYLE, c[i].getValue());
                }
                continue;
            }
			if(name.equals(PARAM_SORT_LIST)) {
				req.setAttribute(PARAM_SORT_LIST, c[i].getValue());
				continue;
			}
			if(name.equals(PARAM_ORDER_LIST)) {
				req.setAttribute(PARAM_ORDER_LIST, c[i].getValue());
				continue;
			}
			if(name.equals(PARAM_ORDER_THREAD)) {
				req.setAttribute(PARAM_ORDER_THREAD, c[i].getValue());
				continue;
			}
			if(name.equals(PARAM_LAST)) {
				int val = 0;
                try {
                    val = Integer.parseInt(c[i].getValue());
                } catch (NumberFormatException e) {
                }
				req.setAttribute(PARAM_LAST, new Integer(val));
				continue;
			}
			if(name.equals(PARAM_NEED_THUMB)) {
				boolean val = true;
				try {
					val = Boolean.valueOf(c[i].getValue()).booleanValue();
				} catch (NumberFormatException e) {
				}
                if(!needThumb) {
                    val = false;
                }
				req.setAttribute(PARAM_NEED_THUMB, new Boolean(val));
				continue;
			}
        }

		if(req.getAttribute(PARAM_STYLE) == null) {
			req.setAttribute(PARAM_STYLE, ".");
		}
    }

    /**
     * s
     * @param request
     * @param response
     * @throws ServletException
     * @throws IOException
     */
    abstract protected void execute(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException;

    /* ( Javadoc)
     * @see javax.servlet.Servlet#init(javax.servlet.ServletConfig)
     */
    public final void init(ServletConfig arg0) throws ServletException {
        super.init(arg0);
        conf = Configures.getConfigures();
        cache = CacheFactory.getInstance();
        node = NodeControllerFactory.getInstance();
        client = Client.getInstance();
        needThumb =  Boolean.valueOf(conf.getParameter(Izayoi.CONFIG_MAKE_THUMB, "false")).booleanValue();
        initalize(arg0);
    }

    /**
     * p javax.servlet.Servlet#init(javax.servlet.ServletConfig) KvȎ͂
     * @param arg0
     * @throws ServletException
     */
    protected void initalize(ServletConfig config) throws ServletException {
    }

    /* ( Javadoc)
     * @see javax.servlet.GenericServlet#log(java.lang.String)
     */
    public void log(String arg0) {
        if (!isSilence) {
            super.log(arg0);
        }
    }

    /* ( Javadoc)
     * @see javax.servlet.GenericServlet#log(java.lang.String, java.lang.Throwable)
     */
    public void log(String arg0, Throwable arg1) {
        if (!isSilence) {
            super.log(arg0, arg1);
        }
    }

    /**
     * "/hogehoge/(1)/(2)/(3)"`犇ʕzƂĒo
     * @param url ͑Ώ
     * @return ʕ̔z (vȂꍇnull)
     */
    protected String[] parseURL(HttpServletRequest request) {
        String root = request.getContextPath();
        String url = request.getRequestURI();
        if(!root.equals("")) {
            url = url.substring(root.length());
        }
        Matcher m = PATTERN_URL.matcher(url);
        if (!m.find()) {
            return null;
        }
        String[] ret = new String[] { m.group(2), m.group(4), m.group(6)};
        return ret;
    }

}
