/**
 * ServletConstants.java
 * Created on 2005/05/16
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.servlet;

import izayoi.Constants;

/**
 * @author es
 */
public interface ServletConstants {

    public static final String PARAM_COMMAND = "command";
    public static final String PARAM_FILE = "file";
    public static final String PARAM_RECORD = "record";
    public static final String PARAM_TYPE = "type";
    public static final String PARAM_NAME = "name";
    public static final String PARAM_MAIL = "mail";
    public static final String PARAM_MESSAGE = "message";
    public static final String PARAM_ATTACH = "attach";
    public static final String PARAM_DOPOST = "dopost";
    public static final String PARAM_SIGN = "signature";
    public static final String PARAM_SORT = "sortkey";
    public static final String PARAM_SORT_LIST = PARAM_SORT + "_" + Constants.TYPE_LIST;
    public static final String PARAM_ORDER = "order";
    public static final String PARAM_ORDER_LIST = PARAM_ORDER + "_" + Constants.TYPE_LIST;
    public static final String PARAM_ORDER_THREAD = PARAM_ORDER + "_" + Constants.TYPE_THREAD;
    public static final String PARAM_BASEID = "baseid";
    public static final String PARAM_BASETIME = "basetime";
    public static final String PARAM_BODY = "body";
    public static final String PARAM_STYLE = "style";
    public static final String PARAM_LAST = "last";
    public static final String PARAM_NEED_THUMB = "needthumb";
    public static final String PARAM_CONTEXT_ROOT = "root";
	
    public static final String COMMAND_COMFIRM_DELETE_FILE = "comfirm-file-delete";
    public static final String COMMAND_DELETE_FILE = "file-delete";
    public static final String COMMAND_COMFIRM_DELETE = "comfirm-delete";
    public static final String COMMAND_DELETE = "delete";
    public static final String COMMAND_POST = "post";
    public static final String COMMAND_NEW = "new";

    public static final String ACTION_CREATE = "create";
    public static final String ACTION_EDIT = "edit";
    public static final String ACTION_POST = "post";
    public static final String ACTION_INDEX = "index";
    public static final String ACTION_HISTORY = "history";
    public static final String ACTION_UPDATE = "update";
    public static final String ACTION_SEARCH = "search";
    public static final String ACTION_VIEW = "view";
    public static final String ACTION_PREF = "pref";

}
