package net.prixdami.alexis.multipart;

import java.io.*;

class BasementMultipartFile implements MultipartFile {
    private String originName;
    private String paramName;
    private String type;
    private File file;

    BasementMultipartFile() {
	}

	BasementMultipartFile(String paramName, String orignName, String mime, File f) {
		setParamName(paramName);
		setOriginName(orignName);
		setType(mime);
		setFile(f);
	}

    /**
     * 
     */
    public void killFile() {
        file.delete();
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.filter.MultipartFile#getParamName()
     */
    public String getParameterName() {
        return paramName;
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.filter.MultipartFile#getFileName()
     */
    public String getFileName() {
        return file.getName();
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.filter.MultipartFile#getOriginFileName()
     */
    public String getOriginFileName() {
        return originName;
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.filter.MultipartFile#getContentType()
     */
    public String getContentType() {
        return type;
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.filter.MultipartFile#getFile()
     */
    public File getFile() {
        return file;
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.filter.MultipartFile#getFileSize()
     */
    public long getFileSize() {
        return file.length();
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.filter.MultipartFile#getInputStream()
     */
    public InputStream getInputStream() throws IOException {
        return new BufferedInputStream(new FileInputStream(file));
    }

    /**
     * @param file
     */
    void setFile(File file) {
        this.file = file;
    }

    /**
     * @param string
     */
    void setOriginName(String string) {
		this.originName = string;
    }

    /**
     * @param string
     */
    void setType(String string) {
		this.type = string;
    }

    /**
     * @param string
     */
    void setParamName(String string) {
		this.paramName = string;
    }

	/* ( Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return getParameterName() + " : " + "[" +  getOriginFileName()+ "] " +  getFileName() + " (" + getContentType() + ") " + getFileSize() + "byte";
	}

}