/*
 * MultipleLineReader.java
 *
 * Created on 2004/07/03, 21:01
 */

package net.sourceforge.shingetsu.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.RandomAccessFile;
import java.io.ByteArrayOutputStream;
import java.io.StringWriter;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.nio.charset.CharsetDecoder;
import java.lang.Thread;
import java.util.Vector;
import java.util.Enumeration;

import net.sourceforge.shingetsu.util.Config;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.lang.InterruptedException;

/**
 * sxɓǂݍރNXłB
 * @author Fuktommy
 * @author stokesia
 */
public class MultipleLineReader {
    
    private static final long LOCK_WAIT_TIME = 500;

    private static final Config config = Config.getInstance();
    
    private static final String encoding = config.getGeneralEncoding();
    private static final int capacity = config.getBufferSize();
    private static final int readBuffersize = 1024 * 256;
    
    private static final String mode = "rwd";
    
    /** Creates a new instance of MultipleLineReader */
    public MultipleLineReader() {
    }
    
    /**
     * w肳ꂽt@C̓o̓`l擾܂B
     * @param file `l擾t@C
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException Ȃ炩̓̓G[ꍇ
     * @return t@C̃`l
     */    
    public static FileChannel getFileChannel(File file) throws FileNotFoundException, IOException {
        FileChannel fileChannel = new RandomAccessFile(file, mode).getChannel();
        
        return fileChannel;
    }
    
    /**
     * t@Cǂݍ݁Asŋ؂sz1vfƂString^̔zԂ
     * ܂B
     * @param channel ǂݍރ`l
     * @return svfƂString^̔z
     * @throws IOException o͂̃G[ꍇ
     */
    public static String[] read(FileChannel channel) throws IOException {
        ByteBuffer byteBuffer = ByteBuffer.allocate(capacity);
        ByteArrayOutputStream byteArray = new ByteArrayOutputStream(readBuffersize);

        byteBuffer.rewind();
        
        int size = 0;

        while((size = channel.read(byteBuffer)) > 0) {
            byte[] bytes = new byte[size];
            
            byteBuffer.flip();
            
            byteBuffer.get(bytes);
            byteArray.write(bytes);
            
            byteBuffer.rewind();
        }

        byte[] bytes = byteArray.toByteArray();
        
        String[] lines = null;
        
        if(bytes.length != 0) {
            String string = new String(bytes, encoding);
            
            string = string.replaceAll("\\r?\\n$", "");
            lines = string.split("\\r?\\n");
        } else {
            lines = new String[0];
        }
        
        return lines;
    }
    
    /**
     * t@Cǂݍ݁Asŋ؂sz1vfƂString^̔zԂ
     * ܂B
     * @param file ǂݍރt@C
     * @return svfƂString^̔z
     * @throws FileNotFoundException Ŏw肳ꂽt@C݂Ȃꍇ
     * @throws IOException o͂̃G[ꍇ
     */
    public static String[] read(File file) throws FileNotFoundException, IOException {
        String readingEncoding  = "ISO-8859-1";

        FileChannel fileChannel = new FileInputStream(file).getChannel();

        String[] lines = read(fileChannel);
        
        fileChannel.close();
        
        return lines;
    }

}
