/*
 * MultipleLineWriter.java
 *
 * Created on 2004/07/17, 17:22
 */

package net.sourceforge.shingetsu.io;

import java.io.File;
import java.io.FileOutputStream;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.nio.charset.CharsetEncoder;
import java.util.Vector;
import java.util.Enumeration;

import net.sourceforge.shingetsu.util.Config;

import java.io.IOException;
import java.io.FileNotFoundException;

/**
 * sxɏ񂾂At@C̖Ɉsދ@\񋟂N
 * XłB
 * @author Fuktommy
 * @author stokesia
 */
public class MultipleLineWriter {
    
    private static final Config config = Config.getInstance();
    private static final String encoding = config.getGeneralEncoding();
    
    private static final String mode = "rwd";

    /** Creates a new instance of MultipleLineWriter */
    public MultipleLineWriter() {
    }
    
    /**
     * w肳ꂽt@C̓o̓`l擾܂B
     * @param file `l擾t@C
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException Ȃ炩̓̓G[ꍇ
     * @return t@C̃`l
     */    
    public static FileChannel getFileChannel(File file) throws FileNotFoundException, IOException {
        FileChannel fileChannel = new RandomAccessFile(file, mode).getChannel();
        
        return fileChannel;
    }

    public static void append(FileChannel channel, String line) throws IOException {
        long position = channel.size();

        channel.position(position);
        
        String[] lines = new String[1];
        lines[0] = line;
        
        write(channel, lines);
    }
    
    public static void append(FileChannel channel, String[] lines) throws IOException {
        long position = channel.size();
        
        channel.position(position);
        
        write(channel, lines);
    }

    public static void write(FileChannel channel, String[] lines) throws IOException {
        for(int i = 0; i < lines.length; i++) {
            String  line = lines[i] + "\r\n";
            byte[] bytes = line.getBytes(encoding);
            ByteBuffer buffer = ByteBuffer.wrap(bytes);
            
            channel.write(buffer);
        }
    }
    
    /**
     * Ŏw肳ꂽt@C̖Ɉs݂܂B
     * @param line ݂
     * @param file ݂t@C
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException o̓G[ꍇ
     */    
    public static void append(String line, File file) throws FileNotFoundException, IOException {
        String[] lines = new String[1];
        lines[0] = line;
        
        append(lines, file);
    }
    
    /**
     * Ŏw肳ꂽt@C̖ɕs݂܂B
     * @param line ݂̔z
     * @param file ݂t@C
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException o̓G[ꍇ
     */    
    public static void append(String[] lines, File file) throws FileNotFoundException, IOException {
        boolean append = true;
        
        write(lines, file, append);
    }
    
    /**
     * Ŏw肳ꂽt@Cɏ݂܂B
     * @param line ݂̔z
     * @param file ݂t@C
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException o̓G[ꍇ
     */    
    public static void write(String[] lines, File file) throws FileNotFoundException, IOException {
        boolean append = false;
        
        write(lines, file, append);
    }
    
    private static void write(String[] lines, File file, boolean append) 
        throws FileNotFoundException, IOException {
        FileChannel fileChannel = new FileOutputStream(file, append).getChannel();
            
        write(fileChannel, lines);
        
        fileChannel.close();
    }
    
}
