/*
 * NodeReader.java
 *
 * Created on 2004/07/03, 20:46
 */

package net.sourceforge.shingetsu.io;

import java.io.File;
import java.util.Vector;
import java.util.Enumeration;

import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.node.Node;
import net.sourceforge.shingetsu.io.MultipleLineReader;

import java.net.MalformedURLException;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * m[ht@Cǂݍރ[_[NXłB
 * @author stokesia
 */
public class NodeReader {
    
    private static final Config config = Config.getInstance();
    private static final File nodeFile = new File(config.getDataDirectory(), 
                                                                                                    config.getNodeFilename());
    
    /** Creates a new instance of NodeReader */
    public NodeReader() {
    }
    
    /**
     * m[hm[ht@Cǂݍ݂܂B
     * @return m[h̔z
     */    
    public static Node[] read() throws FileNotFoundException, IOException {
        String[] nodeListLines = MultipleLineReader.read(nodeFile);
        
        Vector nodeList = new Vector();
        
        for(int i = 0; i < nodeListLines.length; i++) {
            String nodeListLine = nodeListLines[i];
            
            if(nodeListLine.length() != 0) {
                try {
                    nodeList.add(new Node(nodeListLine));
                } catch(MalformedURLException e) {
                    e.printStackTrace();
                }
            }
        }
        
        Node[] nodes = new Node[nodeList.size()];
        
        Enumeration enumeration = nodeList.elements();
        
        for(int i = 0; enumeration.hasMoreElements(); i++) {
            nodes[i] = (Node) enumeration.nextElement();
        }
        
        return nodes;
    }
    
}
