/*
 * Node.java
 *
 * Created on 2004/06/19, 13:57
 */

package net.sourceforge.shingetsu.node;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.Charset;
import java.nio.charset.CharsetDecoder;
import java.util.Enumeration;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import net.sourceforge.shingetsu.util.Config;

/**
 * VfVXẽlbg[N̂ЂƂ̃m[h\NXłBm[h
 * ̗אڃm[hƃR~jP[V킵AXbhAXĝƂs
 * ܂B
 * @author Fuktommy
 * @author stokesia
 */
public class Node {

    //tweak by d55d278e

    //Config config = Config.getInstance();
    private int port;
    //private int port = config.getPort();
    private URL nodeURL;
    private String userAgent;
    //private String userAgent = config.getUserAgent();

    //add
    private String encode;

    /**
     * m[hɒʒm鎩m[h̃|[gԍ
     * @return |[gԍ
     */
    protected int getPort() {
        return port;
    }

    /**
     * m[hɒʒm鎩gUA
     * @return UA
     */
    protected String getUserAgent() {
        return userAgent;
    }

    /**
     * ggpĂGR[h
     * @return GR[h
     */
    protected String getEncoding() {
        return encode;
    }

    /**
     * m[hURLݒ
     * @return URL
     */
    protected void setURL(URL url) {
        nodeURL = url;
    }
    
    /*
     *add constructor 
     */
    protected Node() {
        Config config = Config.getInstance();
        port = config.getPort();
        userAgent = config.getUserAgent();
        encode = config.getGeneralEncoding();
    }
    
    /**
     * w肳ꂽm[hNodeNX̃CX^X𐶐܂B
     * @param url XL[ȗserver.cgiւURL
     * ( www.example.com:8000/server.cgi)
     * @throws MalformedURLException Ɏw肳ꂽvgRmłꍇ
     */
    public Node(String url) throws MalformedURLException {
        this(); //add
        nodeURL = new URL("http://" + url);
    }
    
    /**
     * ̃IuWFNg\m[hɐVvgR̃R}h𔭍s܂B
     * @param command m[hɔsvgRR}h
     * @return X|XString^z
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public String[] talk(String command) throws MalformedURLException, IOException {
        Vector responseRecords = new Vector();
        
        URL commandURL = null;
        URLConnection commandConnection = null;
        
        commandURL = new URL(nodeURL.toString() + command);
        
        commandConnection = commandURL.openConnection();
        
        //tweak
        //commandConnection.setRequestProperty("User-Agent", userAgent);
        commandConnection.setRequestProperty("User-Agent", getUserAgent());
        commandConnection.setRequestProperty("Accept", "text/plain");
        
        commandConnection.connect();

        //tweak
        //CharsetDecoder decoder = Charset.forName(config.getGeneralEncoding()).newDecoder();
        CharsetDecoder decoder = Charset.forName(getEncoding()).newDecoder();
        
        BufferedReader reader = new BufferedReader(
                                                            new InputStreamReader(
                                                                commandConnection.getInputStream(), decoder));
        
        String line = null;
        
        while ((line = reader.readLine()) != null) {
            responseRecords.add(line);
        }
        
        reader.close();
        
        String[] responses = new String[responseRecords.size()];
        Enumeration enumeration = responseRecords.elements();
        
        for (int i = 0; enumeration.hasMoreElements(); i++) {
            responses[i] = (String) enumeration.nextElement();
        }
        
        return responses;
    }

    /**
     * ̃IuWFNg\m[h/pingR}h𔭍sAm[hLǂׂ
     * B
     * @return m[hLłtrue
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public boolean ping() throws MalformedURLException, IOException {
        boolean result = false;
        
        String[] responses = talk("/ping");
        
        /*
        String nodeIPAddress = null;
        
        try {
            nodeIPAddress = InetAddress.getByName(nodeURL.getHost()).getHostAddress();
        } catch(UnknownHostException e) {
            e.printStackTrace();
        }
         */
        
        if(responses.length == 2) {
            //result = (responses[0].equals("PONG")) && (responses[1].equals(nodeIPAddress));
            result = responses[0].equals("PONG") && (responses[1].length() > 0);
        }
        
        return result;
    }
    
    /**
     * ̃IuWFNg\T[og/pingR}h𔭍sAzXgA|[gԍA
     * pXLł邱ƂmFAT[ogɐڑ܂BX|XbZ[W
     * ̃m[h񂪊܂܂Ăꍇ͂̃m[h̃IuWFNgA܂܂ĂȂ
     * Ύg߂lƂĕԂ܂B
     * @return ̃m[h̃IuWFNgA܂͎g
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws ProtocolException T[og̃X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public Node join() throws MalformedURLException, ProtocolException, IOException {
        String[] responses = talk("/ping");
        
        String nodeAddress = null;
        
        if((responses.length >= 2) && responses[0].equals("PONG") && (responses[1].length() > 0)) {
            //nodeAddress = responses[1] + ":" + port + "/server.cgi";
            //tweak
            //nodeAddress = ":" + port + "/server.cgi";
            nodeAddress = ":" + getPort() + "/server.cgi";
            responses = talk("/join/" + escape(nodeAddress));
        } else {
            throw (new ProtocolException("ʐM̃m[hLł͂܂łB"));
        }
        
        Node node = null;

        if(responses.length > 1) {
            if(responses[0].trim().equals("WELCOME")){
                node = new Node(responses[1].trim());
            } else {
                throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
            }
        } else if(responses.length > 0) {
            node = this;
        } else {
            throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
        }
        
        return node;
    }
    
    /**
     * ̃IuWFNg\T[og/pingR}h𔭍sA zXgA|[gԍA
     * pXLł邱ƂmFAڑ܂BX|XbZ[WƂ̏
     * ͐VvgRɏ]܂B
     * @throws ProtocolException X|XbZ[WsAڑɎsꍇ
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public void bye() throws ProtocolException, MalformedURLException, IOException {
        String[] responses = talk("/ping");
        
        String nodeAddress = null;
        
        if((responses.length >= 2) && responses[0].equals("PONG") && (responses[1].length() > 0)) {
            //tweak
            //nodeAddress = responses[1] + ":" + port + "/server.cgi";
            nodeAddress = responses[1] + ":" + getPort() + "/server.cgi";
            responses = talk("/bye/" + escape(nodeAddress));
        } else {
            throw (new ProtocolException("ʐM̃m[hLł͂܂łB"));
        }
        
        if(((responses.length > 0) && responses[0].trim().equals("BYEBYE")) == false) {
            throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
        }
        
    }
    
    /**
     * ̃IuWFNg\T[og/pingR}hŃm[hLł邱ƂmF
     * AT[ogڑĂm[h擾܂B
     * @return T[og瓾m[h
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws ProtocolException T[og̃X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public Node node() throws MalformedURLException, ProtocolException, IOException {
        String[] responses = null;
        
        if(ping()) {
            responses = talk("/node");
        } else {
            throw (new ProtocolException("ʐM̃m[hLł͂܂łB"));
        }
        
        Node node = null;
        
        if(responses.length > 0) {
            node = new Node(responses[0].trim());
        } else {
            throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
        }
        
        return node;
    }
    
    /**
     * ̃IuWFNg\T[ogɈŎw肵t@CĂ邩ǂ
     * 킹܂B
     * @param filename basename16iŕ\ꂽt@C(Agq͕sv)
     * @return ĂtrueAĂȂfalse
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws ProtocolException T[og̃X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public  boolean have(String filename) throws MalformedURLException, 
                                                                                                ProtocolException, IOException {
        String[] responses = null;

        if(ping()) {
            responses = talk("/have/" + filename);
        } else {
            throw (new ProtocolException("ʐM̃m[hLł͂܂łB"));
        }
        
        boolean result = false;
        
        if(responses.length > 0) {
            String message = responses[0].trim();
            
            if(message.equals("YES")) {
                result = true;
            } else if(!message.equals("NO")) {
                throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
            }
        } else {
            throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
        }
        
        return result;
    }
    
    /**
     * ̃IuWFNg\T[ogŎw肵t@CƎɈv
     * s擾܂B
     * @param filename basename16iŕ\ꂽt@C(Agq͕sv)
     * @param timeArgument VvgRɏ]Stringl
     * @return Ŏw肵Ɉvt@C̍s
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws ProtocolException T[og̃X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public  String[]  get(String filename, String timeArgument) throws MalformedURLException, 
                                                                                                ProtocolException, IOException {
        String[] responses = null;

        if(have(filename)) {
            responses = talk("/get/" + filename + "/" + timeArgument);
        } else {
            throw (new ProtocolException("ʐM̃m[ht@CĂ܂łB"));
        }
        
        /*
        if(!(responses.length > 0)) {
            throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
        } 
         */
        
        return responses;
    }
    
  /**
     * ̃IuWFNg\T[ogŎw肵t@CƎɈv
     * s擾܂BAes̎Ǝʎq݂̂Ԃ܂B
     * @param filename basename16iŕ\ꂽt@C(Agq͕sv)
     * @param timeArgument VvgRɏ]Stringl
     * @return Ŏw肵Ɉvt@C̍s
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws ProtocolException T[og̃X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public  String[]  head(String filename, String timeArgument) throws MalformedURLException, 
                                                                                                ProtocolException, IOException {
        String[] responses = null;

        if(have(filename)) {
            responses = talk("/head/" + filename + "/" + timeArgument);
        } else {
            throw (new ProtocolException("ʐM̃m[ht@CĂ܂łB"));
        }
        
        /*
        if(!(responses.length > 0)) {
            throw (new ProtocolException("ʐM̃T[og̃X|XbZ[WsłB"));
        } 
         */
        
        return responses;
    }
    
    /**
     * ̃IuWFNg\T[ogɈŎw肵t@C̍XVm点܂B
     * @param filename basename16iŕ\ꂽt@C(Agq͕sv)
     * @param timeArgument VvgRɏ]Stringl
     * @param md5 {MD5l
     * @param node XVꂽt@Cm[h
     * @throws MalformedURLException T[og̃m[hAhXsȏꍇ
     * @throws ProtocolException T[og̃X|Xsȏꍇ
     * @throws IOException ʐMɓo̓G[ꍇ
     */
    public  void  update(String filename, String timeArgument, String md5, Node node)
        throws MalformedURLException, ProtocolException, IOException {
        String escapedAddress = escape(node.toString());
        
        String message = "/update/" + filename + "/" + timeArgument + "/" + md5 + "/"
                                                + escapedAddress;

        if(ping()) {
            talk(message);
        } else {
            throw (new ProtocolException("ʐM̃m[hLł͂܂łB"));
        }
        
    }
    
    /**
     * m[hŗL̃bZ[W܂B
     * @return m[hŗL̃bZ[W
     */
    public String root() {
        return toString();
    }
    
    /**
     * m[h̕\Ԃ܂B
     * @return m[h̕\
     */
    public String toString() {
        return nodeURL.getHost() + ":" + nodeURL.getPort() + nodeURL.getFile();
    }
    
    /**
     * ̃IuWFNg(m[h)Ɠǂr܂B
     * @param node rΏۂ̃IuWFNg(m[h)
     * @return true
     */
    public boolean equals(Object node) {
        return (this.toString().equals(node.toString()));
    }
    
    /**
     * VvgR̃pXdlɏ][/][+]ɒu܂B
     * @param string uΏۂ̕
     * @return uꂽ
     */
    public String escape(String string) {
        Pattern pattern = Pattern.compile("/");
        Matcher matcher = pattern.matcher(string);
        return (matcher.replaceAll("+"));
    }
    
}
