/*
 * NodeList.java
 *
 * Created on 2004/06/19, 14:04
 */
// $Id: NodeList.java,v 1.17 2005/01/08 11:51:18 stokesia Exp $

package net.sourceforge.shingetsu.node;

import java.io.File;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Random;

import net.sourceforge.shingetsu.io.NodeReader;
import net.sourceforge.shingetsu.io.NodeWriter;
import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.node.Node;

import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * m[hXgňNXłB̃NX̓XgƂĕێĂm[h
 * 삷邽߂̃\bh񋟂Ă܂Bm[h̒ǉA폜Am[hlbg[
 * NɎQAׂẴm[hping𔭍s肷邱Ɠł܂B
 * @author Fuktommy
 * @author stokesia
 */
public class NodeList {
    
    private Config config = Config.getInstance();
    private static NodeList nodeListInstance = new NodeList();
    
    private Vector nodeList = null;
    
    /** Creates a new instance of NodeList */
    private NodeList() {
        nodeList = new Vector();
        read();
    }
    
    public static NodeList getInstance() {
        return nodeListInstance;
    }
    
    private Vector read() {
        Node[] nodes = null;
        
        try {
            nodes = NodeReader.read();
        } catch(FileNotFoundException e) {
            System.err.println("m[h̃t@C݂܂B");
            e.printStackTrace();
        } catch(IOException  e) {
            System.err.println("o͒ɃG[܂B");
            e.printStackTrace();
        }
        
        nodeList.clear();

        for(int i = 0; i < nodes.length; i++) {
            nodeList.add(nodes[i]);
        }
        
        return nodeList;
    }
    
    private void write(Vector nodeList) {
            Node[] nodes = new Node[nodeList.size()];
            
            Enumeration enumeration = nodeList.elements();
            
            for(int i = 0; enumeration.hasMoreElements(); i++) {
                nodes[i] = (Node) enumeration.nextElement();
            }
            
            try {
                NodeWriter.write(nodes);
            } catch(FileNotFoundException e) {
                System.err.println("m[h̃t@C݂܂B");
                e.printStackTrace();
            } catch(IOException  e) {
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }

    }
    
    /**
     * NodeListNX̃IuWFNgQƉ\ȗאڃm[h/pingR}h𔭍sAm[
     * hLł邩ǂׂ܂BAm[hLłȂ΃Xg폜
     * ܂B
     */    
    public void pingAll() {
        Enumeration enumeration = nodeList.elements();
        
        while(enumeration.hasMoreElements()) {
            Node node = (Node) enumeration.nextElement();
            
            try {
                if(!node.ping()) {
                    nodeList.remove(node);
                }
            } catch(MalformedURLException e) {
                nodeList.remove(node);
                System.err.println("m[hAhXsłB");
                e.printStackTrace();
            } catch(ProtocolException e) {
                nodeList.remove(node);
                System.err.println("X|XbZ[WsłB");
                e.printStackTrace();
            } catch(IOException e) {
                nodeList.remove(node);
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }
        }
        
    }
    
    
    /**
     * m[ht@C烉_ɂЂƂm[h擾܂B
     * @return NodeNX̃IuWFNg
     */    
    public Node getRandom() {
        Node node = null;
        
        if(nodeList.size() != 0) {
            node = (Node) nodeList.get(new Random().nextInt(nodeList.size()));
        } else {
            Node[] initNodes = config.getInitNodes();
            node = initNodes[new Random().nextInt(initNodes.length)];
        }
        
        return node;
    }
    
    /**
     * m[hXgm[h̔z擾܂B
     * @return m[h̔z
     */    
    public Node[] getAll() {
        Node[] nodes = new Node[nodeList.size()];
        
        Enumeration enumeration = nodeList.elements();
        
        for(int i = 0; enumeration.hasMoreElements(); i++) {
            nodes[i] = (Node) enumeration.nextElement();
        }
        
        return nodes;
    }
    
    /**
     * m[hXgLȃm[h擾܂B
     * @return Lȃm[h
     */    
    public Node getAvailableNode() {
        Enumeration enumeration = nodeList.elements();
        
        Node node = null;
        
        while(enumeration.hasMoreElements()) {
            node = (Node) enumeration.nextElement();
            
            try {
                if(node.ping()) {
                    break;
                }
            } catch(MalformedURLException e) {
                nodeList.remove(node);
                System.err.println("m[hAhXsłB");
                e.printStackTrace();
            } catch(ProtocolException e) {
                nodeList.remove(node);
                System.err.println("X|XbZ[WsłB");
                e.printStackTrace();
            } catch(IOException e) {
                nodeList.remove(node);
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }
        }
        
        return node;
    }
    
    /**
     * m[hXgɃm[hǉ܂B
     * @param node ǉNodeNX̃IuWFNg
     */    
    public void add(Node node) {
        Node removedNode = null;
        
        if((node != null) && !(nodeList.contains(node))) {
            if(nodeList.size() > (config.getNodeSize() - 1)) {
               	removedNode = (Node) nodeList.remove(new Random().nextInt(nodeList.size()));
            }
            nodeList.add(node);
        }
        
        if(removedNode != null) {
            try {
                if(removedNode.ping()) {
                    removedNode.bye();
                }
            } catch(MalformedURLException e) {
                nodeList.remove(node);
                System.err.println("m[hAhXsłB");
                e.printStackTrace();
            } catch(ProtocolException e) {
                nodeList.remove(node);
                System.err.println("X|XbZ[WsłB");
                e.printStackTrace();
            } catch(IOException e) {
                nodeList.remove(node);
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }
        }
        
    }
    
    /**
     * m[hXgm[h폜܂B
     * @param node 폜NodeNX̃IuWFNg
     */    
    public void remove(Node node) {
        if((node != null) && (nodeList.contains(node))) {
            nodeList.remove(node);
        }

    }
    
    /**
     * ̃m[hXgɊ܂܂Ă邩ǂԂ܂B
     * @param node m[h
     * @return ܂܂Ătrue
     */    
    public boolean contains(Node node) {
        boolean result = false;
        Enumeration enumeration = enumeration();
        
        while(enumeration.hasMoreElements()) {
            Node comparedNode = (Node) enumeration.nextElement();
            
            if(result = comparedNode.equals(node)) {
                break;
            }
        }

        return result;
    }
    
    /**
     * XgŕێĂm[h̐擾܂B
     * @return ێĂm[h
     */    
    public int size() {
        return nodeList.size();
    }
    
    /**
     * m[hXg̗񋓎q擾܂B
     * @return m[hXg̗񋓎q
     */    
    public Enumeration enumeration() {
        return nodeList.elements();
    }
    
    public void synchronize() {
        write(nodeList);
        nodeList = read();
    }
    
}
