/*
 * HttpResponseImpl.java
 *
 * Created on 2004/08/21, 15:03
 */

package net.sourceforge.shingetsu.server;

import java.nio.charset.Charset;
import java.nio.charset.CharsetEncoder;
import java.io.BufferedWriter;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.OutputStream;
import java.lang.Integer;
import java.util.Hashtable;
import java.util.Date;
import java.util.Enumeration;

import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.util.Config;

import java.io.IOException;

/**
 * HttpResponseC^[tFCX̎NXłB
 * @author stokesia
 */
public class HttpResponseImpl implements HttpResponse {
    
    private Config config = Config.getInstance();
    
    private boolean calledWriter = false;
    
    private OutputStream out = null;
    private PrintWriter writer = null;
    private String characterEncoding = config.getGeneralEncoding();
    private String contentType = "text/html; charset=" + characterEncoding;
    private Hashtable responseHeaderTable = null;
    
    private int statusCode = HttpServer.OK;

    /** Creates a new instance of HttpResponseImpl */
    private HttpResponseImpl() {
    }
    
    protected HttpResponseImpl(OutputStream out) {
        this.out = out;
        
        responseHeaderTable = new Hashtable();
    }
    
    public OutputStream getOutputStream() throws IOException, IllegalStateException {
        if(!calledWriter) {
            startSendingResponse();
        } else {
            new IllegalStateException("łɃX|X̂߂̃Xg[Ă΂Ă܂B");
        }
        
        return out;
    }

    public PrintWriter getWriter() throws IOException, IllegalStateException {
        if(!calledWriter) {
            startSendingResponse();
        } else {
            new IllegalStateException("łɃX|X̂߂̃Xg[Ă΂Ă܂B");
        }
        
        return writer;
    }

    public String getContentType() {
        return contentType = null;
    }
    
    public void setContentType(String contentType) {
        if(contentType != null) {
            this.contentType = contentType;
        }
    }
    
    public String getCharacterEncoding() {
        return characterEncoding;
    }
    
    public void setCharacterEncoding(String encoding) {
        if(encoding != null) {
            characterEncoding = encoding;
        }
    }

    public void setStatusCode(int statusCode) {
        this.statusCode = statusCode;
    }
    
    public void setDateHeader(long date) {
        responseHeaderTable.put("Date", new Date(date).toString());
    }

    public void setIntHeader(String name, int value) {
        if((name != null)) {
            responseHeaderTable.put(name, new Integer(value).toString());
        }
    }
    
    public void addHeader(String name, String value) {
        if((name != null) && (value != null)) {
            responseHeaderTable.put(name, value);
        }
    }
    
    private void startSendingResponse() throws IOException {
        CharsetEncoder encoder = Charset.forName(characterEncoding).newEncoder();
        boolean autoFlush = true;
        
        writer = new PrintWriter(new BufferedWriter(
                                new OutputStreamWriter(out, encoder)), autoFlush);
        
        printStatusLine();
        printResponseHeader();
    }
   
    private void printStatusLine() throws IOException {
        StringBuffer buffer = new StringBuffer();
        
        buffer.append(HttpServer.HTTP_VERSION_1_0);
        buffer.append(" " + statusCode);
        buffer.append(" " + HttpServer.getReasonPhrase(statusCode));
        buffer.append(HttpServer.LINE_FEED_CRLF);
        
        writer.print(buffer.toString());
    }
    
    private void printResponseHeader() throws IOException {
        Enumeration enumeration = responseHeaderTable.keys();
        
        while(enumeration.hasMoreElements()) {
            String name = (String) enumeration.nextElement();
            
            if(responseHeaderTable.containsKey(name)) {
                String value = (String) responseHeaderTable.get(name);
                
                writer.print(name + ": " + value + HttpServer.LINE_FEED_CRLF);
            }
        }
        
        writer.print("Connection: close" + HttpServer.LINE_FEED_CRLF);
        
        if(statusCode != HttpServer.FOUND) {
            writer.print("Content-Type: " + contentType + HttpServer.LINE_FEED_CRLF);
            writer.print(HttpServer.LINE_FEED_CRLF);
        }
        
    }
    
}
