/*
 * ContentCGI.java
 *
 * Created on 2004/08/29, 19:40
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.PrintWriter;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.Hashtable;

import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.cgi.CGI;
import net.sourceforge.shingetsu.util.Config;

import java.io.IOException;
import java.io.FileNotFoundException;
import net.sourceforge.shingetsu.server.HttpProtocolException;

/**
 * @̃NX͐ÓIȃRecłHTMLACSSAJPEGt@CNGXgɉ
 * ăX|X܂B
 * @author stokesia
 */
public class ContentCGI extends CGI {
    
    private Config config = Config.getInstance();
    
    private int bufferSize = config.getBufferSize();
    private int responseBufferSize = config.getResponseBufferSize();
    private Hashtable mediaTypeMappingTable = config.getMediaTypeMappingTable();
    
    /** Creates a new instance of ContentCGI */
    public ContentCGI() {
    }
    
    public void excecute(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
    
        String path = request.getPath();
        
        String filePath = config.getDocumentRootDirectory() + path;
        File contentFile = new File(filePath);
        
        if(!contentFile.exists()) {
            String message = "vꂽURL " + request.getPath() + " ͌܂łB";
            throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
        }

        byte[] contentArray = readContentFile(request, contentFile);
        
        String contentType = getMediaType(contentFile);
        
        response.setContentType(contentType);
        response.setIntHeader("Content-Length" ,  contentArray.length);
        
        BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());
        
        out.write(contentArray, 0, contentArray.length);
        out.flush();
        out.close();
    }
    
    private byte[] readContentFile(HttpRequest request, File contentFile) 
        throws HttpProtocolException, IOException {
        BufferedInputStream in = null;
        
        try {
            in = new BufferedInputStream(new FileInputStream(contentFile));
        } catch(FileNotFoundException e) {
            String message = "vꂽURL " + request.getPath() + " ͌܂łB";
            throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
        }
        
        ByteArrayOutputStream byteArray = new ByteArrayOutputStream();
        byte[] buffer = new byte[bufferSize];
        int size = 0;
        
        try {
            while((size = in.read(buffer, 0, bufferSize)) >= 0) {
                byteArray.write(buffer, 0, size);
            }
            
            in.close();
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        return byteArray.toByteArray();
    }
    
    private String getMediaType(File contentFile) {
        String fileName = contentFile.getName();
        int index = fileName.lastIndexOf(".");
        int length = fileName.length() - 1;
        
        String extension = fileName.substring(index, length).toLowerCase();
        
        String mediaType = "application/octet-stream";
        
        if(mediaTypeMappingTable.containsKey(extension)) {
            mediaType = (String) mediaTypeMappingTable.get(extension);
        }
        
        return mediaType;
    }
    
    protected void printFooter(HttpResponse response, PrintWriter writer)
            throws HttpProtocolException, IOException {
                
    }
    
    protected void printHeader(HttpResponse response, PrintWriter writer, String title)
            throws HttpProtocolException, IOException {
                
    }
    
}
