/*
 * GatewayCGI.java
 *
 * Created on 2004/08/21, 21:18
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.PrintWriter;
import java.io.File;
import java.text.SimpleDateFormat;
import java.text.DateFormat;
import java.util.Vector;
import java.util.Date;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Hashtable;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import net.sourceforge.shingetsu.cache.Cache;
import net.sourceforge.shingetsu.io.DataFilenameFilter;
import net.sourceforge.shingetsu.io.MultipleLineReader;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.server.cgi.PlugIn;
import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.util.RecordComparator;

import java.lang.NullPointerException;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;

import net.sourceforge.shingetsu.server.HttpProtocolException;

/**
 * ̃NXgateway.cgiɑCGINXłB
 * @author stokesia
 */
public class GatewayCGI extends PlugIn {
    
    private Config config = Config.getInstance();
    
    private final static int INDEX_MODE = 1;
    private final static int HISTORY_MODE = 2;
    
    private String[] indexNames = {"Xg", "Xbh", "m[g"};
    
    private Comparator comparator = new RecordComparator();
    
    /** Creates a new instance of GatewayCGI */
    public GatewayCGI() {
    }
    
    public void excecute(HttpRequest request, HttpResponse response) 
            throws HttpProtocolException, IOException {
            String path = request.getPath();

            if(path.matches("(^/gateway.cgi)|(^/)")) {
                printGatewayIndex(request, response);
            } else if(path.matches("^/gateway.cgi/create")) {
                printCreatePage(request, response);
            } else if(path.matches("^/gateway.cgi/index")) {
                printIndex(request, response, INDEX_MODE);
            } else if(path.matches("^/gateway.cgi/history")) {
                printIndex(request, response, HISTORY_MODE);
            } else {
                String message = "vꂽURL " + request.getPath() + " ͌܂łB";
                throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
            }
            
    }
    
    private void printGatewayIndex(HttpRequest request, HttpResponse response) 
            throws HttpProtocolException, IOException {
            PrintWriter writer = response.getWriter();
            
            String title = "V - P2Pf";

            super.printHeader(response, writer, title);
            super.printMenu(response, writer, title);
            
            writer.println("<p>VGNUʌOp_񏑂ɊÂĔzz܂</p>");
            writer.println("<ul>");
            writer.println("	<li><em><a href=\"/list.cgi\">j[</a></em></li>");
            writer.println("	<li><a href=\"http://shingetsu.sourceforge.net/\">TCg</a></li>");
            writer.println("	<li><a href=\"/motd.txt\">lbg[Np</a></li>");
            writer.println("</ul>");
            
            super.printFooter(response, writer);
    }
    
    private void printCreatePage(HttpRequest request, HttpResponse response) 
            throws HttpProtocolException, IOException {
            PrintWriter writer = response.getWriter();
            
            String menu = "menu";
            String filename = null;
            
            try {
                filename = TYPE_LIST + "_" + toHexString(menu);
            } catch(UnsupportedEncodingException e) {
                String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
            
            String title = "VK쐬";

            super.printHeader(response, writer, title);
            super.printMenu(response, writer, title);
            super.printCreateFile(response, writer, filename);
            super.printFooter(response, writer);
    }
    
    private void printIndex(HttpRequest request, HttpResponse response, int mode)
        throws HttpProtocolException, IOException {
        String[] listRecords = getRecords(TYPE_LIST, mode);
        String[] threadRecords = getRecords(TYPE_THREAD, mode);
        String[] noteRecords = getRecords(TYPE_NOTE, mode);
        
        String[][] categories = new String[3][];
        
        categories[0] = listRecords;
        categories[1] = threadRecords;
        categories[2] = noteRecords;
        
        PrintWriter writer = response.getWriter();
        
        String menu = "menu";
        String filename = null;
        
        try {
            filename = TYPE_LIST + "_" + toHexString(menu);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String title = "ꗗ";
        
        super.printHeader(response, writer, title);
        super.printMenu(response, writer, title);
        
        writer.println("<form method=\"get\" action=\"/delete.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"comfirm-file-delete\" />");
        writer.println("</p>");
        
        for(int i = 0; i < indexNames.length; i++) {
            String[] records = categories[i];
            
            writer.println("<h2>" + indexNames[i] + "</h2>");
            writer.println("<ul>");
            
            for(int index = records.length - 1; index >= 0; index--) {
                writer.println(records[index]);
            }
            
            writer.println("</ul>");
        }
        
        writer.println("</ul>");
        writer.println("<p>");
        writer.println("<input type=\"submit\" value=\"t@C폜\" tabindex=\"2\" accesskey=\"d\" />");
        writer.println("</p>");
        writer.println("</form>");

        super.printCreateFile(response, writer, filename);
        super.printFooter(response, writer);
    }
    
    private String[] getRecords(String type, int mode) throws HttpProtocolException, IOException {
        String dataDirectoryPath = config.getDataDirectory() + File.separator;
        File dataDirectory = new File(dataDirectoryPath);
        
        File[] files = dataDirectory.listFiles(new DataFilenameFilter(type));
        
        String[] records = new String[files.length];
        Vector recordList = new Vector();
        Hashtable clonedRecord = new Hashtable();
        
        for(int i = 0; i < files.length; i++) {
            Hashtable record = (Hashtable) clonedRecord.clone();
            record = createLinkRecord(files[i], record, mode);
            
            if(record != null) {
                recordList.add(record);
            }
        }
        
        Object[] recordArray = recordList.toArray();
        
        if(mode == HISTORY_MODE) {
            Arrays.sort(recordArray, comparator);
        }
        
        records = new String[recordArray.length];
        
        for(int i = 0; i < records.length; i++) {
            Hashtable record = (Hashtable) recordArray[i];
            records[i] = (String) record.get(FIELD_NAME_BODY);
        }
        
        return records;
    }
    
    private Hashtable createLinkRecord(File file, Hashtable record, int mode) 
        throws HttpProtocolException {
        String[] tokens = file.getName().split(File.separator);
        String filename = tokens[0];
        
        String type = detectType(filename);
        String basename = detectBaename(filename);

        String name = null;
        String encodedName = null;
        
        try {
            name = toString(detectBaename(filename));
            encodedName = encode(name);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String length = getLengthByMB(file.length()) + "MB";
        
        Cache cache = getCache(file);
        String recordCount = null;
        String lastRecord = null;
        
            try {
                cache.lock();
                
                recordCount = Integer.toString(cache.getRecordCount());
                lastRecord = cache.getLastRecord();
                
                cache.unlock();
                cache.close();
            } catch(FileNotFoundException e) {
                String message = "Ŏw肳ꂽt@C "  + file.getName() + " ݂܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            } catch(IOException e) {
                String message = "t@C̓o͒ɃG[܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        
        if(lastRecord == null) {
            return null;
        }

        tokens = lastRecord.split("<>");
        
        String timeStamp = tokens[0];
        String id = tokens[1];
        
        String date = null;
        
        if(mode == HISTORY_MODE) {
            long time = 0L;
            
            try {
                time = Long.parseLong(timeStamp) * 1000L;
            } catch(NumberFormatException e) {
                String message = "t@C " + file.getName() + " ̎ʎq " + id + " ̓t̏słB";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
            
            DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm");
            date = dateFormat.format(new Date(time));
        }
        
	filename = type + "_" + basename;

        String linkRecord = "<li><input type=\"radio\" name=\"file\" value=\"" + filename +"\" tabindex=\"1\" accesskey=\"s\" />";
                                             
        if(date != null) {
            linkRecord += date + " ";
        }
                                             
        linkRecord += "<a href=\"/" + type + ".cgi/" + encodedName + "\">" + name + "</a>"
                                + "(" + recordCount + "/" + length + ") </li>";
        
        record.put(FIELD_NAME_TIMESTAMP, timeStamp);
        record.put(FIELD_NAME_ID, id);
        record.put(FIELD_NAME_BODY, linkRecord);
        
        return record;
    }
    
    private Cache getCache(File file) throws HttpProtocolException {
        Cache cache = null;
        
	try {
            cache = new Cache(file);
        } catch(NullPointerException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " nullłB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        return cache;
    }

}
